=== ubuntu/ixxat/Makefile ===
mod-name += ixx_usb
obj-m += ixx_usb.o
ixx_usb-objs := ixx_usb_cl1.o ixx_usb_cl2.o ixx_usb_core.o
